diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index d7e4749..e01a9ec 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -1907,14 +1618,14 @@ _cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len)
     case SLAPI_OPERATION_ADD:
         _cl5WriteString(op->p.p_add.parentuniqueid, &pos);
         _cl5WriteString(rawDN, &pos);
-        _cl5WriteMods(add_mods, &pos);
+        _cl5WriteMods(add_mods, &pos, clcrypt_handle);
         slapi_ch_free((void **)&rawDN);
         ldap_mods_free(add_mods, 1);
         break;
 
     case SLAPI_OPERATION_MODIFY:
         _cl5WriteString(REPL_GET_DN(&op->target_address), &pos);
-        _cl5WriteMods(op->p.p_modify.modify_mods, &pos);
+        _cl5WriteMods(op->p.p_modify.modify_mods, &pos, clcrypt_handle);
         break;
 
     case SLAPI_OPERATION_MODRDN:
@@ -1924,7 +1635,7 @@ _cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len)
         pos++;
         _cl5WriteString(REPL_GET_DN(&op->p.p_modrdn.modrdn_newsuperior_address), &pos);
         _cl5WriteString(op->p.p_modrdn.modrdn_newsuperior_address.uniqueid, &pos);
-        _cl5WriteMods(op->p.p_modrdn.modrdn_mods, &pos);
+        _cl5WriteMods(op->p.p_modrdn.modrdn_mods, &pos, clcrypt_handle);
         break;
 
     case SLAPI_OPERATION_DELETE:
@@ -1960,7 +1671,7 @@ _cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len)
 
 
 int
-cl5DBData2Entry(const char *data, PRUint32 len __attribute__((unused)), CL5Entry *entry)
+cl5DBData2Entry(const char *data, PRUint32 len __attribute__((unused)), CL5Entry *entry, void *clcrypt_handle)
 {
     int rc;
     PRUint8 version;
@@ -2016,7 +1727,7 @@ cl5DBData2Entry(const char *data, PRUint32 len __attribute__((unused)), CL5Entry
         _cl5ReadString(&rawDN, &pos);
         op->target_address.sdn = slapi_sdn_new_dn_passin(rawDN);
         /* convert mods to entry */
-        rc = _cl5ReadMods(&add_mods, &pos);
+        rc = _cl5ReadMods(&add_mods, &pos, clcrypt_handle);
         slapi_mods2entry(&(op->p.p_add.target_entry), rawDN, add_mods);
         ldap_mods_free(add_mods, 1);
         break;
@@ -2024,7 +1735,7 @@ cl5DBData2Entry(const char *data, PRUint32 len __attribute__((unused)), CL5Entry
     case SLAPI_OPERATION_MODIFY:
         _cl5ReadString(&rawDN, &pos);
         op->target_address.sdn = slapi_sdn_new_dn_passin(rawDN);
-        rc = _cl5ReadMods(&op->p.p_modify.modify_mods, &pos);
+        rc = _cl5ReadMods(&op->p.p_modify.modify_mods, &pos, clcrypt_handle);
         break;
 
     case SLAPI_OPERATION_MODRDN:
@@ -2036,7 +1747,7 @@ cl5DBData2Entry(const char *data, PRUint32 len __attribute__((unused)), CL5Entry
         _cl5ReadString(&rawDN, &pos);
         op->p.p_modrdn.modrdn_newsuperior_address.sdn = slapi_sdn_new_dn_passin(rawDN);
         _cl5ReadString(&op->p.p_modrdn.modrdn_newsuperior_address.uniqueid, &pos);
-        rc = _cl5ReadMods(&op->p.p_modrdn.modrdn_mods, &pos);
+        rc = _cl5ReadMods(&op->p.p_modrdn.modrdn_mods, &pos, clcrypt_handle);
         break;
 
     case SLAPI_OPERATION_DELETE:
@@ -2057,17 +1768,17 @@ cl5DBData2Entry(const char *data, PRUint32 len __attribute__((unused)), CL5Entry
 
 /* thread management functions */
 static int
-_cl5DispatchDBThreads(void)
+_cl5DispatchTrimThread(Replica *replica)
 {
     PRThread *pth = NULL;
 
     pth = PR_CreateThread(PR_USER_THREAD, (VFP)(void *)_cl5TrimMain,
-                          NULL, PR_PRIORITY_NORMAL, PR_GLOBAL_THREAD,
+                          (void *)replica, PR_PRIORITY_NORMAL, PR_GLOBAL_THREAD,
                           PR_UNJOINABLE_THREAD, DEFAULT_THREAD_STACKSIZE);
     if (NULL == pth) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DispatchDBThreads - Failed to create trimming thread"
-                      "; NSPR error - %d\n",
+                      "_cl5DispatchTrimThread - Failed to create trimming thread for %s"
+                      "; NSPR error - %d\n", replica_get_name(replica),
                       PR_GetError());
         return CL5_SYSTEM_ERROR;
     }
@@ -2151,7 +1862,7 @@ _cl5ReadString(char **str, char **buff)
    <4 byte size><value1><4 byte size><value2>...
  */
 static void
-_cl5WriteMods(LDAPMod **mods, char **buff)
+_cl5WriteMods(LDAPMod **mods, char **buff, void *clcrypt_handle)
 {
     PRInt32 i;
     char *mod_start;
@@ -2165,7 +1876,7 @@ _cl5WriteMods(LDAPMod **mods, char **buff)
 
     /* write mods*/
     for (i = 0; mods[i]; i++) {
-        if (0 <= _cl5WriteMod(mods[i], &mod_start)) {
+        if (0 <= _cl5WriteMod(mods[i], &mod_start, clcrypt_handle)) {
             count++;
         }
     }
@@ -2183,7 +1894,7 @@ _cl5WriteMods(LDAPMod **mods, char **buff)
  *     netative: failed to encrypt && no write to the changelog
  */
 static int
-_cl5WriteMod(LDAPMod *mod, char **buff)
+_cl5WriteMod(LDAPMod *mod, char **buff, void *clcrypt_handle)
 {
     char *orig_pos;
     char *pos;
@@ -2226,7 +1937,7 @@ _cl5WriteMod(LDAPMod *mod, char **buff)
     bv = slapi_mod_get_first_value(&smod);
     while (bv) {
         encbv = NULL;
-        rc = clcrypt_encrypt_value(s_cl5Desc.clcrypt_handle,
+        rc = clcrypt_encrypt_value(clcrypt_handle,
                                    bv, &encbv);
         if (rc > 0) {
             /* no encryption needed. use the original bv */
@@ -2271,7 +1982,7 @@ _cl5WriteMod(LDAPMod *mod, char **buff)
  */
 
 static int
-_cl5ReadMods(LDAPMod ***mods, char **buff)
+_cl5ReadMods(LDAPMod ***mods, char **buff, void *clcrypt_handle)
 {
     char *pos = *buff;
     int i;
@@ -2289,7 +2000,7 @@ _cl5ReadMods(LDAPMod ***mods, char **buff)
     slapi_mods_init(&smods, mod_count);
 
     for (i = 0; i < mod_count; i++) {
-        rc = _cl5ReadMod(&smod, &pos);
+        rc = _cl5ReadMod(&smod, &pos, clcrypt_handle);
         if (rc != CL5_SUCCESS) {
             slapi_mods_done(&smods);
             return rc;
@@ -2307,7 +2018,7 @@ _cl5ReadMods(LDAPMod ***mods, char **buff)
 }
 
 static int
-_cl5ReadMod(Slapi_Mod *smod, char **buff)
+_cl5ReadMod(Slapi_Mod *smod, char **buff, void *clcrypt_handle)
 {
     char *pos = *buff;
     int i;
@@ -2338,7 +2049,7 @@ _cl5ReadMod(Slapi_Mod *smod, char **buff)
         _cl5ReadBerval(&bv, &pos);
         decbv = NULL;
         rc = 0;
-        rc = clcrypt_decrypt_value(s_cl5Desc.clcrypt_handle,
+        rc = clcrypt_decrypt_value(clcrypt_handle,
                                    &bv, &decbv);
         if (rc > 0) {
             /* not encrypted. use the original bv */
@@ -2351,11 +2062,11 @@ _cl5ReadMod(Slapi_Mod *smod, char **buff)
             char *encend = encstr + 128;
             char *ptr;
             int i;
-            for (i = 0, ptr = encstr; (i < bv.bv_len) && (ptr < encend - 4);
+            for (i = 0, ptr = encstr; (i < bv.bv_len) && (ptr < encend - 6);
                  i++, ptr += 3) {
                 sprintf(ptr, "%x", 0xff & bv.bv_val[i]);
             }
-            if (ptr >= encend - 4) {
+            if (ptr >= encend - 6) {
                 sprintf(ptr, "...");
                 ptr += 3;
             }
@@ -2544,7 +2255,7 @@ _cl5WriteBervals(struct berval **bv, char **buff, u_int32_t *size)
 static int32_t
 _cl5CheckCSNinCL(const ruv_enum_data *element, void *arg)
 {
-    CL5DBFile *file = (CL5DBFile *)arg;
+    cldb_Handle *cldb = (cldb_Handle *)arg;
     int rc = 0;
 
     DBT key = {0}, data = {0};
